
package orchid.gui;

import java.util.GregorianCalendar;
import java.util.Date;
import java.util.SimpleTimeZone;
import java.util.TimeZone;
import java.util.Calendar;

/**
 * A class used to calculate dates and others infos for the Perpetual Calendar. <BR>
 * @see MeetingAgentWindow 
 * @author Frdric Salvy
 */
public class Calculation {


 public GregorianCalendar initCalendar() {
 // get the supported ids for GMT+01:00 (Paris Time)
 //String[] def=TimeZone.getAvailableIDs();
 String[] ids = TimeZone.getAvailableIDs(+1 * 60 * 60 * 1000);
 // if no ids were returned, something is wrong. get out.
 if (ids.length == 0)
     System.exit(0);
    // begin output

 // create a Paris Time time zone
 SimpleTimeZone paris = new SimpleTimeZone(+1 * 60 * 60 * 1000, ids[0]);
 // set up rules for daylight savings time
 paris.setStartRule(Calendar.APRIL, 1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
 paris.setEndRule(Calendar.OCTOBER, -1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
 // create a GregorianCalendar with the Pacific Daylight time zone
 // and the current date and time
 GregorianCalendar calendar = new GregorianCalendar(paris);
 return calendar;
 }

 // Sunday<->1, Monday <->2,
 // JANUARY<->0
 
 public Date getTodayDate() {
  GregorianCalendar calendar= initCalendar();
  Date today = new Date();
  return  today;
 }

 public int getTodayTimeHour() {
 GregorianCalendar calendar= initCalendar();

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.HOUR_OF_DAY);
 }

 public int getTodayTimeMinute() {
 GregorianCalendar calendar= initCalendar();

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.MINUTE);
 }

 public int getTodayTimeSecond() {
 GregorianCalendar calendar= initCalendar();

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.SECOND);
 }


 public int getTodayDay() {
 GregorianCalendar calendar= initCalendar();
 // le jour courant

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.DAY_OF_MONTH);
 }

 public int getTodayMonth() {
 GregorianCalendar calendar= initCalendar();
 // le mois courant

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.MONTH);
 }

 public int getTodayYear() {
 GregorianCalendar calendar= initCalendar();
 // l'anne courante

    Date today = new Date();
    calendar.setTime(today);
    return  calendar.get(Calendar.YEAR);
 }


 public int setTime(int date, int month, int year) {
 GregorianCalendar calendar= initCalendar();

 calendar.set(Calendar.YEAR, year);
 // JANUARY<->0
 calendar.set(Calendar.MONTH, month);
 calendar.set(Calendar.DATE, date);


 // Sunday<->1, Monday <->2,
 return (calendar.get(Calendar.DAY_OF_WEEK)+5) % 7+1 ;
 }

 public int getNbOfDayInMonth(int month, int year) {
 GregorianCalendar calendar= initCalendar();
 // l'anne courante

    calendar.set(Calendar.YEAR, year);
    // JANUARY<->0
    calendar.set(Calendar.MONTH, month);
    calendar.set(Calendar.DATE, 31);


 if (calendar.get(Calendar.DATE)==31) return 31;
 else {
      // Fvrier
      if (month==1)
          {if (calendar.isLeapYear(year)) return 29; return 28;}
      else return 30;
      }
 }

}
