
package orchid.gui;

import com.objectspace.voyager.*;

/** This is the class to call on the client side.<P>
 * Use : Connect can be run with or without argument like shown in examples below :<P>
 * java Connect 				(connection to the default server)<BR>
 * java Connect 192.168.1.105:10000		(connection to server i5.esiea.fr, port 10000)<BR>
 * java Connect i5.esiea.fr:10000		(connection to server i5.esiea.fr, port 10000)<BR>
 * @author Marc-Aurle DARCHE
 */
public class Connect {

	static public void main(String args[]) {
		//String defaultServer= new String("192.168.1.105:10000");
		String defaultServer= new String("127.0.0.1:10000");
		if (args.length>0) { defaultServer= args[0]; }
		orchid.object.FileUtil fu=new orchid.object.FileUtil();
		fu.setServer(defaultServer);

		String client_osArch= new String(System.getProperty("os.arch"));
		String client_osName= new String(System.getProperty("os.name"));
		String client_osVersion= new String(System.getProperty("os.version"));
		System.out.println("\n\n- *** Getting System Properties *** -");
		System.out.println("Java installation directory : "+System.getProperty("java.home"));
		System.out.println("Java vendor : "+System.getProperty("java.vendor"));
		System.out.println("Java vendor URL : "+System.getProperty("java.vendor.url"));
		System.out.println("Java version number : "+System.getProperty("java.version"));
		System.out.println("System "+client_osName+" "+client_osVersion+" on a "+client_osArch);
		LoginWindow lw= new LoginWindow();
		lw.init();
		lw.start();
		System.out.println("- *** ORCHID Client (Feb 1999): started on a "+client_osName+" machine -\n");
		
		try{
			Voyager.startup("//localhost:11000");
			orchid.object.Util.logMsg("info","Connect","Voyager successfully started");
		} catch (Exception ve) { orchid.object.Util.logMsg("error","Connect","Voyager not started"); }

	}
}

