package orchid.object;

import java.util.*;
import java.io.*;

/**
 * A class whose only purpose is to explain how orchid objects are to be manipulated.
 * <P>The objects to arrange a meeting are used in this order :
 * <ol>
 * <li> MeetingProposal
 * <li> DateHourProposal
 * <li> RangeProposal
 * <li> Meeting
 * </ol>
 * @see MeetingProposal
 * @see DateHourProposal 
 * @see RangeProposal
 * @see Meeting
 * @author Marc-Aurle DARCHE
 */
public class ObjectTest {

	public static void main (String args[]){

	System.out.println("\n* Orchid objects are generally manipulated in the following order: 1,2,3,4");
	System.out.println("\n1. Meeting proposals");
	String pl1[]= new String[3];
	GuestInfo g1= new GuestInfo("antoine.souliez",true);
	Hashtable ht= new Hashtable();
	ht.put("antoine.souliez",g1);
	MeetingProposal mp1= new MeetingProposal("runion tped","dfinition du terme agent","ma_darche",1998,8,28,1998,9,10,400,ht,24);
	System.out.println(mp1.toString());
	
	System.out.println("\n2. DateHour proposals");
	DateHourProposal dhp1= new DateHourProposal(1998,9,1,900);
	System.out.println(dhp1.toString());	
	DateHourProposal dhp2= new DateHourProposal(1998,9,2,1400);
	System.out.println(dhp2.toString());
	DateHourProposal dhp3= new DateHourProposal(1998,9,7,1100);
	System.out.println(dhp3.toString());	
	DateHourProposal dhp4= new DateHourProposal(1998,9,7,900);
	System.out.println(dhp4.toString());	
	
	System.out.println("\n3. Range proposals");
	RangeProposal rp = new RangeProposal(mp1.getRangeLength());
	
	Calendar fromCal = Calendar.getInstance();
	fromCal.set(1998,8,28,0,0,0);
	
	try {rp.setMeeting(fromCal.getTime(),dhp1,mp1.getDuration());} catch (IOException ioe) {}
	System.out.println(rp.toString());
	try {rp.setMeeting(fromCal.getTime(),dhp2,mp1.getDuration());} catch (IOException ioe) {} 
	System.out.println(rp.toString());
	try {rp.setMeeting(fromCal.getTime(),dhp3,mp1.getDuration());} catch (IOException ioe) {} 
	System.out.println(rp.toString());
	try {rp.setMeeting(fromCal.getTime(),dhp4,mp1.getDuration());} catch (IOException ioe) {} 
	System.out.println(rp.toString());

	System.out.println("\n4. Meetings");
	mp1.getGuestInfoList();
	Vector v= new Vector();
	v.addElement("antoine.souliez");
	Meeting m1= new Meeting(mp1.getSubject(),mp1.getNote(),mp1.getInitiator(),1998,8,28,900,mp1.getDuration(),v,false);
	m1.setDate(1998,9,1);
	m1.setTimeOfDay(1200);
	m1.setFrozen(true);
	System.out.println(m1.toString());	
	System.out.println("");	
	
	System.out.println(Util.getServer());
	}
}

