package orchid.object;

/**
 * The User object.<P>
 * Contains all the data concerning a user.<BR>
 * The User object has to implement <b>Serializable</b> to be carried by agents,
 * since agents are serialized when manipulated by Voyager.<BR>
 * Serializable requires<TT><b> import java.io.Serializable;</b></TT>
 * @author Marc-Aurle DARCHE
 */
public class UserInfo implements java.io.Serializable {

	private String name="";
	private String home="127.0.0.1:10000";
	private String info="";
	private String profile="";
	private boolean online=true;

	public UserInfo(String name) {
		this.name= name;
	}

	public UserInfo(String name, String home) {
		this.name= name;
		this.home= home;
	}

	public String getName(){
		return this.name;
	}

	public String getHome(){
		return this.home;
	}

	public String toString() {
		String displayString= "";
		displayString = displayString+this.name;
		return displayString;
	}

}

