
package orchid.object;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.io.*;

/**
 * A class including useful functions for ORCHID.<P>
 * @author Marc-Aurle DARCHE & Antoine SOULIEZ
 */
public class Util {
	
	public static void setServer(String server){
		File servers_listFile= new File("orchid/gui/servers_list");
		try {
			RandomAccessFile file= new RandomAccessFile(servers_listFile,"rw");
			file.writeBytes(server+"\n");	
			file.writeBytes("\n");	
			file.close();
		} catch (java.io.IOException ioe) {
			System.err.println(ioe);
		}
	}
	
	public static String getServer(){
		File servers_listFile= new File("orchid/gui/servers_list");
		String server="";
		try {
			RandomAccessFile file= new RandomAccessFile(servers_listFile,"r");
			server=file.readLine();
			/*
			while ( (server=file.readLine()) != null ) {
				System.out.println("server = "+server);
			}
			*/
			file.close();
		} catch (java.io.IOException ioe) {
			System.err.println(ioe);
		}
		return server;
	}

	/*  Maybe a StringTokenizer could be used to make this method simpler... */
	public static Vector stringToVector(String s){
		Vector v= new Vector();
		StringBuffer resultstring= new StringBuffer(s);
		StringBuffer resulttemp= new StringBuffer();
		StringBuffer temp= new StringBuffer();
		while (resultstring.toString().indexOf(" ")!=-1){
			temp.setLength(0);
			temp.append(resultstring.toString().substring(0,resultstring.toString().indexOf(" ")));
			if ( !(temp.toString().equals("")) ){
				v.addElement(temp.toString());
			}
			resulttemp.setLength(0);
			resulttemp.append( resultstring.toString().substring(resultstring.toString().indexOf(" ")+1) );
			resultstring.setLength(0);
			resultstring.append(resulttemp.toString());
		}
		v.addElement(resultstring.toString());
		return v;
	}

	public static String vectorToSQLList(Vector v){
		StringBuffer content= new StringBuffer();
		for (int i=0; i<v.size(); i++){
			content.append("'");
			content.append((String) v.elementAt(i));
			content.append("'");
			content.append(",");
		}
		 String finalString="("+content.toString();
		return finalString.substring(0,(finalString.length() - 1))+")";
	}

	public static Vector enumToVector(Enumeration e)
		{
			Vector v = new Vector();
			while (e.hasMoreElements())
				v.addElement(e.nextElement());
			return v;
		}

	public static Hashtable enumToHashtable(Enumeration e)
		{
			Object i;
			Hashtable h = new Hashtable();
			while (e.hasMoreElements())
				{
					i = e.nextElement();
					h.put(i.toString(),i);
				}
			return h;
		}

	/** Display a message.
	 * purpose can be info, error, panic or alert.
	 */
	public static void logMsg(String purpose, String identity, String message)
		{
			if (((purpose.toLowerCase()).equals("error")) ||
					((purpose.toLowerCase()).equals("panic")) ||
					((purpose.toLowerCase()).equals("alert")))
				System.err.println("<"+purpose.toUpperCase()+" from "+identity+" > "+message);
			else
				System.out.println("["+purpose+" from "+identity+" ] "+message);
			
		}
	
	/** Sort the CF
	 */
	public static Vector sortCF(Hashtable tobesorted)
		{
			Vector vkeys = new Vector(tobesorted.size());
			Vector vprop = new Vector(tobesorted.size());
			boolean placefound;
			int place;
			String keytoinsert = new String();
			int CFtoinsert;
			String keytocompare = new String();
			int CFtocompare;
			
			Enumeration e = tobesorted.keys();

			while (e.hasMoreElements())
				{
					placefound = false;
					place = 0;
					keytoinsert = (String) e.nextElement();
					CFtoinsert = ((Integer) tobesorted.get(keytoinsert)).intValue();
					Enumeration eex = vkeys.elements();
					while ((eex.hasMoreElements()) && (!placefound))
						{
							keytocompare = (String) eex.nextElement();
							CFtocompare = ((Integer) vprop.elementAt(place)).intValue();
							if (CFtoinsert > CFtocompare)
								placefound = true;
							else
								if ((CFtocompare == CFtoinsert) && (keytocompare.compareTo(keytoinsert) > 0))
									placefound = true;
								else
									place ++;
						}
					if (placefound)
						{
							vkeys.insertElementAt(keytoinsert,place);
							vprop.insertElementAt(tobesorted.get(keytoinsert),place);
						}
					else
						{
							vkeys.addElement(keytoinsert);
							vprop.addElement(tobesorted.get(keytoinsert));
						}
				}
			return vkeys;
		}

	/** 
	 * Check if the content of a String is an int.
	 */
	public static boolean validateInteger(String strtotest) {
		try {
			int duration=new Integer(strtotest).intValue();
		} catch (NumberFormatException excep) { 
			return false;  
		}
		return true;
	}

	/** 
	 * Check if a String is a valide date
	 */
	public static boolean validateDate(String strtotest) {
		String start=strtotest;
		try {
			String lengthtest=start.substring(0,9);
		} catch (Exception excep) {
			return false;
		}    
		
		int duration=0;int count=1; int index=0; String value="";
		boolean test=true;
		while ( count<3 ) {
			index=start.indexOf("/");
			value=start.substring(0,index);
			start=start.substring(index+1,start.length());
			count++;	
			try {
				duration=new Integer(value).intValue();

				if ( ((duration<1)||(duration>31)) && (count==2)) test=false;
				if ( ((duration<1)||(duration>12)) && (count==3)) test=false;
				if ((start.length() != 4) && (count==3)) test=false;
				try {
					if (test==false) {
						int temp=new Integer("gf").intValue();
					}
				} catch (NumberFormatException excep) {
				logMsg("error","validateDate","Please enter a valid range for day&month\nFormat :   dd/mm/yyyy");
				return false;
				}
			} catch (NumberFormatException excep) {
				logMsg("error","validateDate","Please enter a valid date Format :   dd/mm/yyyy");
				return false;
			}
		}
		return true;
	}
}

